Introduction

EMMA Labs web site

Navigation: »No topics above this level«

Advanced Direct Remailer
No contents entries on this page
Contents
Topic functions menu
Menu
This is the first topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Advanced Direct Remailer (ADR) is a unique software for sending e-mails. ADR ensures faster, safer, and more easy-to-control mail sending. And thus it helps to save your time and money. You don't have to change anything, nor have you to cease using the system you've got used to if you don't want to - any software you currently use can be easily configured to work with ADR. And you get an easy-to-use powerful tool for mass and personified mailing!

Fast mailing. Let's consider two instances. Instance one: you're an ordinary e-mail user. Instance two: you have a mailing list and send hundreds or thousands messages a day. However, in both instances you use mail server of your ISP to send e-mails.

So, instance one. How is your e-mail going? First, your mail client sends a message to your ISP's mail server. ISP's server puts your e-mail in outgoing messages queue. When turn of your e-mail comes, it is sent to your correspondent's mail server. And only after that your correspondent can receive it.

If the server is not overloaded, delivering a message takes just a few seconds. But this also might take minutes or even hours! But how often you need that your partner receive the message before he goes out to lunch, as after lunch he is leaving for a meeting? And ten minutes the message had waited in the outgoing mail queue in your ISP's server could be crucial. In such a situation, ADR will ensure instant delivery of your message, as it sends it bypassing your ISP's mail server. And saves minutes that are sometimes so precious. No queues, no delays!

Consider instance two. Have you faced a situation when sending a pretty nice thousand of messages 1 K each through your ISP's mail server took 2 or 3 hours? Yes, your modem is fast, but you can't use even 50% of its power - SMTP protocol is very slow, and that's not your ISP's fault.

ADR uses direct multi-thread delivery - it sends several messages directly to your correspondents' mail servers simultaneously. ADR ensures 100% usage of your modem capabilities, or whatever percentage you want.

Safe delivery. ADR excludes your ISP's server from the message path. In many countries local legislation requires from communication service operator to grant security service access to the users correspondence. So, your messages most probably are stored in the ISP's system for some time. But if a message doesn't come through ISP's mail system, it leaves no trace in its logs, and, furthermore, it is not stored in the system - like with files downloaded through FTP or with web-pages viewed with your browser.

Yes, of course, your ISP can detect your mail traffic and intercept it. But ADR doesn't pretend to be a guarantor of your privacy, as even encrypting systems sometimes fail to ensure this.

Controlled delivery. Now you have a full-function mail server at your disposal! This enables you to control your mail traffic. So, you can schedule sending large batches of mail using mailing list for lunchtime and dinnertime only. You can view contents of all outgoing messages and create an archive of your company's outgoing messages. ADR logs will always advise you who, when, and to whom have sent messages. Furthermore, your employees will be able to send mail much faster - as the mail server is within your local network now!

Organizations using mass mail sending often face a "dead addresses" problem - sometimes, up to 20%..30% of letters are returned with the message that the e-mail address doesn't exist any more. This means that a half of traffic was wasted. ADR, using direct mailing, detects up to 90% of the "dead" addresses at the very beginning of sending procedure, thus solving the problem.

Moreover, ADR can send messages using a mailing list, so you don't need to buy a special software. The system of supporting user mail processing software - so called plugins - allows you to easily configure the program to fulfil any tasks, whatever complicated they are - from the simplest personified sending or sending new serial numbers and passwords to your users, to creating special applications to link your mail system with your company's database.

Easy-to-configure. You want to use ADR for fast mail sending, but don't want to stop using the system of personified delivery you've got used to? That's as easy as ABC! You just have to change the address of outgoing mail server (SMTP) in your personified delivery software from your ISP's server to local ADR server - 127.0.0.1 That's all!

Program overview

© 2009-2014 EMMA Labs


Program overview
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Unlike many other programs for mass mail sending, Advanced Direct Remailer (ADR) has no built-in message editor. Contemporary mail programs are very complicated - they can create messages in HTML format, with sound, scripts, graphics, complex layouts; they support many languages and national encodings; they can encrypt messages using PGP or another system. ADR doesn't require from you to study a new system for creating messages - you already have software well familiar to you, where you have your address book, messages archive, properly configured encrypting system and your own message templates.

ADR includes it's own SMTP server, and any software can be configured to send mail through ADR. You just have to change only one entry in your software settings! In the article "Configuring Mail Clients" you can find useful hints to configuring most popular mail clients. Properly configured, your mail client instead of sending your message to ISP, will send it to ADR for prompt delivery.

After launching ADR its icon appears in the screen corner near system clock (system tray). You can open the main ADR window - Monitor - by left-clicking the mouse or by choosing the "Open Monitor" item in the menu activated by right-clicking the mouse.

Monitor displays contents of the three folders - OutBox, Sent and Bad. You can switch from one folder to another using tabs at the right or through the Window menu. When the internal mail server receives a message from your mail client, it is placed in the OutBox folder. After the message is sent it is saved in Sent folder. If ADR fails to send a message, it is moved to Bad folder. Let's consider these folders in more details.

In OutBox folder you can see the entire queue of outgoing messages. Messages being currently sent are marked with blue triangles. The number of messages in OutBox is displayed in OutBx field of the status bar, the number of messages being currently sent is displayed in InSnd field. You can enable/disable sending through the Delivery menu, change messages sorting by clicking column headings or through the View menu, and you can view the message sending log, delete highlighted message or a group of message from the queue through the Message menu.

Successfully sent messages are placed in the Sent folder. To save the disk space, you can configure ADR so that sent messages be deleted instead of being placed in the Sent folder. Or you can configure ADR to delete messages in this folder after several days. You can also delete sent messages manually or resend them through the Message menu.

Messages that proved impossible to deliver are placed in the Bad folder. The reason of non-delivery is displayed in the "Reason" column. You can also view the message delivery log and send it to ADR technical support service, or to your system administrator/recipient's node administrator, if you are unsure that ADR operated properly. If the letter was not delivered due to temporal failure of the recipient's node, you can resend it using the Message menu.

You can totally control ADR through Monitor menu, some commands from menu are duplicated on toolbar:

close | Close Monitor window. To open Monitor window again, click on ADR icon in system tray by left mouse button, or click by right mouse button and choose appropriate item from program menu.
isp | Switch direct delivery (directly to recipient server) to delivery through Internet Service Provider server. It’s useful when mail servers of some your correspondents are temporarily down and you have no permanent Internet connection.
play | Run delivery. Set number of delivery threads (the number of simultaneously sending messages) on “Deliverу” tab in program settings. Use “Actions” tab to configure ADR for automatic run of message sending.
pause | Pause delivery, this method is recommended to end the messages sending. ADR complete the delivery of sending messages and only then stop the sending.
stop | Stop delivery. The sending is stopped instantly and delivery of sending messages is interrupted.
log | View selected message log. You can configure log to save only last try result or result of all delivery tries.
resend | Resend message. You can send message from Bad or Sent folder again.
delete | Delete message. Delete message file on hard disk and message log – so the message never can be restored.
help | Program help. Pay attention, in ADR setting window there is “Help” button on each page which open help for this page and each setting item have its context help.
homepage | Advanced Direct Remailer Internet homepage. There you can find the latest information about program, updates and links to others our products.

Internal SMTP server and mailboxes


How to...

EMMA Labs web site

Navigation: Working with the program:

How to…
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

This article contains short advice about how to work with Advanced Direct Remailer. You will know more about program’s possibilities if you read this article.

How to start the work with ADR after installation?

If you have direct Internet connection you can do no settings in ADR. You only have to set your mail program for mail delivery through ADR replacing SMTP mail server address by localhost (see “Mail program settings”). If you are in LAN and don’t have real IP address, only address like 10.1.1.5, you have to set program for working through Socks5 proxy server (see “Setting of Proxy”).

How to set mailing by database?

ADR supports mailing lists formed on fly by SQL database request (see “Mailing list formats”). Use FromSQL plugin for merging a mailing with database and printing information from database by message-template (see “About FromSQL plugin”).

How to make XRay plugin process all messages?

Since ADR 1.3 version you can process with plugin’s help all outcoming messages, but not only messages sending by mailing list. Just create adr-any box and add to it XRay plugin (see “Special mailboxes”).

How to increase the speed of message delivery?

When ADR deliver message not through provider (“Delivery via ISP” is turn off) it extract mail server address from DNS, connect with server and send the message. The connection with DNS servers using by default may take about 2-3 seconds. To shorten this time till 0.5 second it is recommended to set DNS addresses of your provider (see “Setting of DNS”). You can also increase number of simultaneously sending messages (see “Setting of Delivery”).

How better to end the delivery?

You can end the delivery using Stop or Pause button. In first case the delivery ends immediately, so there is a risk that some message delivery will be interrupted near its end when mail server have receive the message, but the session was not finished. Then such message will be marked as “not delivered” and ADR will be try to deliver it next time. The second variant is more preferable besause ADR will complete the started message deliveries without starting new deliveries.

How to set X program for working with ADR?

If a program deliver mail using SMTP protocol then you can configure it for working with ADR. Just replace SMTP mail server address in X program by localhost (see “Mail program setting”). So, you can configure for working with ADR any mail program, mail server, mass mailer and etc.

How to send letters for some domains through ISP?

If you want to send all letters through ISP, then turn on the “Delivery via ISP” switch in Monitor window. If you want to send letters for some domains through ISP and the others letters – directly, you can do it in ADR since version 1.52 by the “delay list”.

Program overview


Delay list using

EMMA Labs web site

Navigation: Working with the program:

Delay list
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Some mail servers have advanced protection from the spammers, so a part of “quite legal” letters can be don’t delivered to its recipients. The America On-Line (AOL.COM) has the especially ill fame. Even if you send only a several tens of letters to AOL in a short space of time, there is a chance, that AOL filters will be switched on and your letters will be dropped. AOL doesn’t inform you that your IP address is locked and the letters from your email doesn’t received anymore. AOL successfully receives all letters and… drop them. Note, that this problems concern only those who send letters by big mailing list and don’t concern those who use ADR only as remailer.

The one from the ways to pass the anti-spam AOL filter is to send letters one by one at 1-2 minutes intervals. For that ADR has the special list with domains to which you want to send letters with delay. This list is called “delay list”. The list is located in DELAY.LST file in the directory with Advanced Direct Remailer and it contains the records like:

Aol.com 180

This record means that the next letter to AOL.COM must be sent waiting 180 seconds (3 minutes) after the previous letter sending. So, the letters to AOL.COM will be sent in one stream at 3 minutes intervals. The letters to the domains, which are not in list, will be sent without delay.

Note, that the delay list is loaded one time when the program run. Rerun the program if you have made changes in the list. The number of domains in the list isn’t limited. Use the “General” tab to switch on or off the delay list. It isn’t used by default.

The delay doesn’t work when a message is sent through ISP, it works only for direct delivery. The delay, if it’s needed, is realized after extraction the addresses of SMTP servers from DNS and before the connection with SMTP server. So ADR puts the letters for nonexistent domain in “Bad” folder without delay.

For example, you switch on the 3 minutes delay for AOL.COM domain and send the letters to addresses 1@AOL.COM, 2@AOL.COM and 3@AOL.COM. The delivery for all letters start at the same time and all they will be marked in “Outbox” by the blue triangle, but one from the letters will be sent immediately and two another will be sent through 3 and 6 minutes correspondingly. You can see the next records in its message logs:

Wait by delay list...

It means that the letters was delayed for a certain time according to the settings in delay list.

The second way to pass the AOL filters is to send letters to AOL through ISP (Internet Server Provider). AOL has the list of trusted addresses from which it receives the mails without any limitations. So the big ISP can send a several letters at one minute to AOL.COM. To always send letters for given domain through ISP, set 0 in delay list as value of delay for this domain. For example:

Aol.com 0

In this case all letters to AOL.COM will be sent through ISP, independently from state of the “Delivery via ISP” switch.

Program overview


Installation as Windows service
No contents entries on this page
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

You can install ADR as service under Windows XP or higher. That allows ADR to send and receive mail while you don’t log in yet or if you log off already. Because the service run when Windows loading before user login. See Windows help system to know details about the services.

To install ADR as service, just run the ADR Service Manager

Program overview


Internal SMTP server and mailboxes
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

ADR has no built-in message editor, but it has internal SMTP server, and you can configure your mail client to work with ADR as described in "Configuring Mail Client" article.

Besides providing for connection of your mail client with ADR, the internal mail server has one more important function - supporting mailing lists. Mailing lists are set up through configuring mailboxes on the "Mailboxes" tab in ADR settings.

ADR mailbox is not a message storage. When a mailbox is set up, mailing lists and plugins are linked to it. When a message gets into the mailbox, it is delivered using mailing lists linked to that mailbox and is processed by the relevant plugins. All the resulting messaged are placed in the OutBox folder.

Several mailboxes were set up along with setting up ADR. Feel free to send messages using that lists - they contain our test addresses.

The simplest mailbox is called "simple", it contains only one mailing list. A message sent to the address simple@localhost (if you have changed local domain of the mail server, change the address respectively, too) will be multiplied as specified in the list stored in simple.lst file. ADR support not only lists with emails, ADR can create lists with SQL transaction on fly. See “Mailing list formats” to learn more and sqlmail mailbox.

Normally, when mail client sends message using a mailing list, the list address is to be typed in "To:" field. ADR can replace this address with the address of actual recipient, if the relevant option is enabled. Withname mailbox contains withname.lst list, where e-mail addresses are in standard form. When you use this list with the relevant option enabled, the recipient will see his/her real name in the "To:" field.

A more complex example is sendnum. It contains a list and a plugin - user's mail processing program. When you send mail to sendnum@localhost, each message to be sent using the sendnum.lst list will be processed by the sendnum.exe (or sendnum.dll) program. This program searches for %SENDNUM% sequence in the message body and replaces it with the first line from file sendnum.dat. After that, the first line of sendnum.dat file is deleted. For example, this plugin is helpful when you need to send new serial numbers to your users. You have to create sendnum.lst containing addresses of your users and sendnum.dat containing the list of serial numbers. And the work that could take days will be done in a few minutes! sendnum.exe is distributed with sources in C language, and you can easily modify it to expand capabilities of this plugin.

The xray example contains a mailing list and XRay plugin, which is distributed with Delphi sources. This plugin is designed for cuting out some lines from messages header (kludges), the beginnings of lines are specified in XRay.CFG file. E.g., you can cut lines with your mailer identifier (X-Mailer) or message path in your internal mail system. AdKludge plugin solve inverse problem. It add service lines (kludges) from file AdKludge.CFG to message header. This plugin and it’s Delphi v3 source code are placed in “plugins” subdirectory of Advanced Direct Remailer.

The realname example designed for personified delivery works in a similar way. File realname.dat contains e-mail addresses and real names of the recipients. Plugin searches for %REALNAME% sequence in the message and replaces it with real name of the recipient. If realname.dat contains no name corresponding to the e-mail address, the default name set after single @ symbol in realname.dat is used. For example, in a message starting with the following line:

Hello, %REALNAME%!

the line will be replaced with:

Hello, John Smith!

The same plugin can be used for some other purposes - e.g. to send serial numbers or other personified information to your users.

If your mailbox is linked to several mailing lists (m1.txt, m2.txt, m3.txt) and several plugins (e1.exe, e2.exe, e3.exe), the system will work as follows. The program will create a message for the first address from m1.txt. Then it will launch e1.exe, with message file name and its path as the first parameter in command prompt. When e1.exe finishes processing the message, e2.exe will be launched with the message name in the command prompt, and then - e3.exe will be launched. After the message is processed by all the plugins, it is placed in the end of the queue in the OutBox folder. It will be sent when its turn comes. After the first message is moved to the OutBox folder, a message for the second address in the m1.txt will be created, etc. Having sent messages to all the addresses in m1.txt the program starts processing the list m2.txt, and then - m3.txt.

Plugin can delete a message passed to it for processing if it considers it undeliverable. For example, if there are no more serial numbers in the list. Executable files (.exe and .com), special Dynamic Link Libraries (.dll) and batch files (.bat) can be plugins.

ADR messages format is very simple, so you or your programmers can easily create new message processing programs.

About DLL versions of plugins, Program overview, Information for programmers, About FromSQL plugin


Special mailboxes
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Since 1.3 version user’s programs for message processing (plugins) can process any message sending through ADR, but not only messages sending by mailing list. If you don’t know plugin’s ideology read “Internal SMTP server and mailboxes” article first.

So, three special mail boxes appear: adr-any, adr-list, adr-notlist. They have the following feature: you can add to them only plugins, but you can’t add mailing lists. Plugins added to adr-any process all messages sending through ADR. Plugins added to adr-list process all messages sending by any mailing list and they are executed after plugins added to box with mailing list. Plugins added to adr-notlist process all messages sending through ADR except messages sending by mailing lists.

For example, if you want XRay plugin process all outcoming messages create adr-any mail box and add to it this plugin. Similarly, if you want realname plugin process all messages sending by any mailing list create adr-list box and add to it this plugin.

The messages are processed in such order. The messages sending through ADR not by mailing list are processed at first by plugins added to adr-notlist box (if it’s created), then by plugins added to adr-any box (if it’s created). The messages sending through ADR by mailing list, e.g. realname, at first are processed by plugins added to the box with mailing list and then by plugins added to adr-list box (if it’s created) and only then by plugins added to adr-any box.

Internal SMTP server and mailboxes


Mailing list formats
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Four following mailing list formats are supported:

1. Simple mailing lists (.TXT, .LST)

2. Comma separeated values (.CSV) lists

3. SQL mailing lists (.SQL)

4. Windows Address Books (.WAB)

Program overview


About DLL versions of plugins
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Since ADR version 1.5 the new plugin’s format is available, the special Dynamic Link Libraries (.DLL). They don’t differ from usual EXE-plugins from the user’s point of view. And if you have two plugin versions (.EXE and .DLL) you can use any from them. However, the new .DLL versions are more preferred, because they work 2..4 times faster. Now there are .DLL versions for all old .EXE-plugins from ADR distributive.

.EXE plugin version is run again for each message copy. And if you process the mailing with the thousand of addresses by plugin, the program will start thousand times. The new plugins in .DLL format are loaded once before tossing (mailing by list) and the special function will be called to process each message. The .DLL will be unloaded after end of tossing. The .DLL version usage save your time in 2..4 times and decrease the CPU and hard disk loading.

The description below is for the programmers. After .DLL plugin loading, ADR tries to import AdrPlugin function from the library. In case of failure ADR tries to import _AdrPlugin function and in case of repeated failure – the function with the 10 number. This function must have the next prototype:

DWORD WINAPI AdrPlugin(char* MessageFileName); /* C/C++ notation */

function AdrPlugin(MessageFileName : PChar) : Integer; stdcall; /* Delphi notation */

ADR don’t use the value returned by function. But it’s recommended to return 0 or 1 value to avoid possible conflicts with the future versions. ADR call the function from the plugin to process the message and specify the whole path and name of file with message. The most of ADR .DLL plugins are distributed with C or Delphi source codes, and you can learn them if you have any question.

The TestDLL utility was created to test DLL-plugins without ADR. The utility is distributed with its source code. You can apply to its code to know about plugin’s loading mechanism and how to work with them.

Internal SMTP server and mailboxes, Information for programmers


About SendNum plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

See example Sendnum on “Mailboxes” tab in “General Settings”. It contains a list and a plugin - user's mail processing program. When you send mail to sendnum@localhost, each message to be sent using the sendnum.lst list will be processed by the sendnum.exe (sendnum.dll) program. This program searches for %SENDNUM% sequence in the message body and replaces it with the first line from file sendnum.dat. After that, the first line of sendnum.dat file is deleted.

For example, this plugin is helpful when you need to send new serial numbers to your users. You have to create sendnum.lst containing addresses of your users and sendnum.dat containing the list of serial numbers. And the work that could take days will be done in a few minutes!

Sendnum.exe (sendnum.dll) is distributed with sources in C language, and you can easily modify it to expand capabilities of this plugin. We provide both .EXE and .DLL versions of this plugin. You can use any version, but .DLL version is faster.

Internal SMTP server and mailboxes


About RealName plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The Realname example designed for personified delivery works in a similar way. File realname.dat contains e-mail addresses and real names of the recipients. Plugin searches for %REALNAME% sequence in the message and replaces it with real name of the recipient. If realname.dat contains no name corresponding to the e-mail address, the default name set after single @ symbol in realname.dat is used. For example, in a message starting with the following line:

Hello, %REALNAME%!

the line will be replaced with:

Hello, John Smith!

The same plugin can be used for some other purposes - e.g. to send serial numbers or other personified information to your users. Realname.exe (realname.dll) is distributed with sources in C language. We provide both .EXE and .DLL versions of this plugin. You can use any version, but .DLL version is faster.

About RealName2 plugin, Internal SMTP server and mailboxes


About RealName2 plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The RealName2 plugin is intended for the same aim as RealName plugin. File realname2.dat contains e-mail addresses and real names of the recipients. The format of this file is:

Default User Name

John Smith <john@domain.com>

Vlad Kat <kitten@soft.com>

Plugin searches for %REALNAME% sequence in the message and replaces it with real name of the recipient. If realname2.dat contains no name corresponding to the e-mail address, then default name is used, specified in the first line of file. For example, the line :

Hello, %REALNAME%!

In letter, sent to address john@domain.com, will be replaced by :

Hello, John Smith!

The same plugin can be used for some other purposes - e.g. to send serial numbers or other personified information to your users. Realname2.exe (realname2.dll) is distributed with sources in C language. We provide both .EXE and .DLL versions of this plugin. You can use any version, but .DLL version is faster.

About RealName plugin, Internal SMTP server and mailboxes


About XRay plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The xray example (see “Mailboxes” tab in “General Settings”) contains a mailing list and XRay plugin, which is distributed with Delphi sources. This plugin is designed for cuting out some lines from messages header (kludges), the beginnings of lines are specified in XRay.CFG file. E.g., you can cut lines with your mailer identifier (X-Mailer) or message path in your internal mail system. This plugin and it’s Delphi v3 source code are placed in “plugins” subdirectory of Advanced Direct Remailer. We provide both .EXE and .DLL versions of this plugin. You can use any version, but .DLL version is faster. Xray support single line kludges only. To process all outcoming mail with this plugin add it to “adr-any” mailbox (see “Special mailboxes” article). AdKludge plugin solve inverse problem.

Internal SMTP server and mailboxes


About AdKludge plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

AdKludge plugin add service lines (kludges) from file AdKludge.CFG to message header. E.g. you can add “ List-Unsubscribe:” kludge to messages in your mailing list. This plugin and it’s Delphi v3 source code are placed in “plugins” subdirectory of Advanced Direct Remailer. We provide both .EXE and .DLL versions of this plugin. You can use any version, but .DLL version is faster. To process all outcoming mail with this plugin add it to “adr-any” mailbox (see “Special mailboxes” article). XRay plugin solve inverse problem.

Internal SMTP server and mailboxes


About FromSQL plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

FromSQL plugin is intended for merger of database and mail list. FromSQL works with database through ODBC, so it can interact with both Microsoft Excel file and big database under Microsoft SQL Server or Oracle control. Read “Internal SMTP server and mailboxes” article carefully if you don’t know ADR plugin ideology.

This article is intended for advanced users who have skills of work with DBMS or Microsoft Excel and who know basis of SQL. This article is about plugin purposes and its setting. Also there are solutions of practical tasks with FromSQL plugin help.

For example, you have such table:

customers

------------------------------------------

name email account

------------------------------------------

Smith recycled0@pisem.net 756320

Doe recycled1@pisem.net 89201

Green recycled2@pisem.net 103990

------------------------------------------

and you must send the following message each month for all users:

Dear Mr. Smith,

thank you for your interest to our project.

Your account is $756320 now.

Support Team,

support@support.com

FromSQL plugin can help you to automate this process. Just create mail box, add to it mail list with recipients addresses and FromSQL plugin. The setting of FromSQL plugin is realized through FromSQL.INI file, which is in the same directory as plugin.

In settings you must indicate name of ODBC data source, name and password for data access. User’s password and name may be empty. You must configure SQL-request for receiving data from database. Set the name of file with SQL-request in Request parameter in FromSQL.INI. If there is no file path so it is in the same directory as plugin.

The request in this case must be like this:

SELECT name, account FROM customers WHERE email='%recipient%'

%recipient% macro will be replaced in request by recipient email. Plugin replace %%1%%, %%2%% and etc macro in the message by the first, second and etc column value of the first line of SQL-request result. For example, the initial message:

Dear Mr. %%1%%,

thank you for your interest to our project.

Your account is $%%2%% now.

Support Team,

support@support.com

after request:

SELECT name, account FROM customers WHERE email='recycled0@pisem.net'

will look like the message at the beginning of article. Pay attention that if SQL-request return several lines then all lines except the first will be ignored.

Microsoft Excel file may be used as data source. For that ODBC drivers for Excel (from Microsoft Office) must be installed. In directory with plugin there is FromSQL.XLS file which is for our example demonstration.

Choose “ODBC Data Source” item in “Control Panel”. Choose Excel driver and create user DSN. Call data source as “FromSQL” and indicate workbook as FromSQL.XLS, which is in directory with plugin. During installation the program have created fromsql mailbox which is constructed for our example. You have to only create “FromSQL” data source to completely set this example.

Now you can send message to fromsql@localhost address and make sure that the setting is correct. You can see also the created messages in MAIL\OUT directory of Advanced Direct Remailer.

Another important note about Excel documents. Before use such document as database table give name for each list area which play a part of table. So in FromSQL.XLS file the customers name is given for $A$1:$C$33 cells ("Insert" -> "Name" -> "Define"). The names of table columns are the values of the first cells of named area, for our example A1, B1, C1 cells.

We don’t give examples for a large DBMS such as Microsoft SQL Server because the administrators of such bases can configure FromSQL plugin without any assistance. Otherwise apply to us and we'll try to help you.

Starting with 1.1 ADR version you can use not only early formed mailing lists, but mailing lists formed on fly by database SQL-request. Read “Mailing list formats” article to know more about SQL-lists.

About SQLTable plugin, About FromCSV plugin, Internal SMTP server and mailboxes, Mailing list formats


About SQLTable plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Plugin SqlTable is similar to plugin FromSQL, but it works with SQL-requests that return several lines. Whereas FromSQL takes only the first line of values obtained as a result of the SELECT request and replaces macros in a message with respective values (e.g., all macros %%1%% in letter will be replaced with the value from the first column of the first line of the request result), SqlTable processes all lines of the request result.

To ensure that, macro %sqltable% is added. Usage example:

Dear sir,

please, see our price list below.

%sqltable%

Position: %%1%%

Price: $%%2%%

%sqltable%

WBR,

Sales Team

The plugin will repeat the block between %sqltable% macros for each line of the result and print values from the line columns in it. E.g. as a result of the request

SELECT position, price FROM price_list

the plugin will modify a message as follows:

Dear sir,

please, see our price list below.

Position: Advanced Direct Remailer

Price: $40

Position: Advanced Maillist Verify

Price: $40

Position: Advanced Email Parser

Price: $149

Position: Advanced Email Extractor

Price: $40

Position: Advanced Email Extractor PRO

Price: $99

WBR,

Sales Team

Configuration file of the plugin is similar to that of FromSQL and is extended with the following parameters:

Rowname. This parameter allows changing macro %sqltable% to any other. For example, to process a message in several runs.

FormatLeft and FormatRight set formatting parameters for long lines of a result. To disable formatting, set these values to 0.

SqlTable plugin files are located in the plugins subfolder of the Advanced Direct Remailer folder.

About FromSQL plugin, About FromCSV plugin, Internal SMTP server and mailboxes


About FromCSV plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

FromCSV plugin is intended for merging mailing with data from CSV file (Comma Separated Values), like FromSQL plugin provide a merging mailing with database. Microsoft Excel, Outlook Express and other popular programs support data export to CSV files. Please, read “Internal SMTP server and mailboxes” article if ADR plugins ideology is not familiar to you.

.EXE and .DLL versions of plugin are in \plugins\FromCSV subdirectory of the directory with Advanced Direct Remailer. The plugin use FromCSV.INI configuration file and FromCSV.CSV data file. Also, you can find its complete C++ source code in plugin’s subdirectory. Plugin was compiled by Microsoft Visual C++ 6.0.

CSV file is datasheet. The first line of file is banner headline. The rest ones are data. The example of CSV file:

Name, Email, Web Page, ID

Alexander Gorlach, gorlach@mail.com, www.mailutilities.com, 10282

Andrey Cherezov, ac@eserv.ru, www.etype.net, 12992

TheBat Team, support@ritlabs.com, www.ritlabs.com, 11020

Val Kat, vkat@soft.com, www.soft.com, 10230

The values in file must be in quotes (e.g., “Vladimir Katalov, Managing Director”), if they contain separator character. The list separator character is specified in regional settings of operating system. Also you can override this setting in FromCSV.INI configuration file.

Use %%1%%, %%2%%, etc. macros to substitute values into the letter template. This macros refer to data from the first, second and following “columns” of CSV file. Also you can use %%Name%% instead of %%1%%, %%Email%% instead of %%2%%, %%Web Page%% instead of %%3%% and so on for given example, according with columns names in CSV file. Note that macros are case sensitive (%%EMAIL%% is not equivalent to %%Email%%). For example, the next letter:

From: info@mydomain.com

To: %%Name%% <ac@eserv.ru>

Hello, %%1%%!

We add your web-page %%Web Page%% to our directory. Please,

check us here:

http://mydomain.com/%%ID%%.html

Thank you, %%1%%!

MyDomain Team

www.mydomain.com

will be changed into the following letter (the data from line contained recipient address ac@eserv.ru will be used) after its processing by FromCSV plugin:

From: info@mydomain.com

To: Andrey Cherezov <ac@eserv.ru>

Hello, Andrey Cherezov!

We add your web-page www.etype.net to our directory. Please,

check us here:

http://mydomain.com/12992.html

Thank you, Andrey Cherezov!

MyDomain Team

www.mydomain.com

The letter example and CSV file example are placed in directory with plugin.

About FromSQL plugin, Internal SMTP server and mailboxes


About AdrDelay plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

ADR creates the separate copy of letter for each address in mailing list, so a large disk space may be required for sending a big letter by a large mailing list. AdrDelay helps to solve this problem.

Plugin reads MaxOutboxMessages parameter (it’s 500 by default) from AdrDelay.INI file. When plugin run for processing the next message sent by mailing list, it check the number of messages in directory with outgoing mail and wait while this number become less than MaxOutboxMessages value. So, the creation messages by list is interrupted temporarily after creation the given number of messages and is resumed only after sending the part of messages. Also it’s recommended to use “Delete message after sending” setting for saving disk space.

AdrDelay.exe (AdrDelay.dll) is distributed with sources in C language. We provide both .EXE and .DLL versions of this plugin. You can use any version, but .DLL version is faster.

Internal SMTP server and mailboxes


About MsgID plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Each message can contains in its header optional unique identifier (Message-ID), the mail server can catch by it and delete duplicated messages. Some programs, e.g. Aureate GroupMail, don’t use message identifiers.

The MsgID plug-in add the unique identifier to processing message and replace it if the message has identifier already. The message created by Outlook Express has the identifier, and all derived messages will have the same identifier if such message wil be sent by list. We don’t know about letter losing in practice, but there is such risk in theory because of possible errors in servers software. So it’s recommended to add MsgID plug-in to mailboxes.

MsgID is distributed with sources in C language. We provide .DLL version of this plugin only.

Internal SMTP server and mailboxes


About ExclList plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

ExclList plugin is intended for creation of exclusion lists. You can exclude addresses, which are present in separate exclusion list, from mailing by adding this plugin to mailbox with mailing list. Add this plugin to a special mailbox (e.g., adr-any) and you globally prohibit mail sending through ADR to addresses from exclusion list. To block the domain, use * instead of mailbox name. E.g., *@ftc.org ban all emails in FTC.ORG domain.

.EXE and .DLL versions of plugin are in \plugins\ExclList subdirectory of the directory with Advanced Direct Remailer. The plugin use ExclList.INI configuration file and ExclList.LST data file. Also, you can find its complete C++ source code in plugin’s subdirectory. Plugin was compiled by Microsoft Visual C++ 6.0.

According to the settings in ExclList.INI file, plugin can either delete messages, which recipient address present in ExclList.LST list, or save such messages in specified folder. ExclList.LST file contains list of addresses, where there is one address in each line, e.g.:

John Smith <xxx@xxx.com>

gates@microsoft.com

"Join to us!" <jointo@ourentrants.com>

"this @ is dog" <dog@ask.com>

*@ftc.org

bgates@micro$oft.com <bgates@microsoft.com>

Internal SMTP server and mailboxes


About Recipient plugin
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

This plug-in replace %recipient% string in message by recipient email address. It may be useful when you should write something like:

-----------------------------------------

TO UNSUBSCRIBE, SEND BLANK MESSAGE TO

MAILTO:ROBOT@MYDOMAIN.COM?SUBJECT=%recipient%

-----------------------------------------

The %recipient% macro is case sensitive. .EXE and .DLL versions of plug-in are in \plugins\Recipient subdirectory of the directory with Advanced Direct Remailer. Also, you can find its complete C source code in plug-in’s subdirectory.

Internal SMTP server and mailboxes


Setting of program
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The setting of program is caused in menu “Delivery” of Monitor by choosing of “General Settings...” item. In appeared window you will see several tabs with settings:

General tab, Actions tab, DNS tab, Delivery tab, Server tab, Mailboxes tab, Proxy tab, Logs tab


General settings
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Run program when Windows startup

Run program when Windows startup. The alternative is to place program shortcut to “Start” folder in “Run” button.

Show Monitor window always topmost

Tick off this option to place an open Monitor window always on top of others system windows.

Delete message after sending

Delete message after sending and don’t place they to Sent folder. It is recommended to use this setting or erase Sent folder sometimes manually. Also, you can configure ADR to store messages in Sent specified number of days only.

Forward undelivered mail to sender

When this option is turned off, message sent to nonexistent address will be moved into the “Bad” folder. Otherwise, message will be returned to sender. For that, new message will be formed with attached source message and delivery log. The sender and recipient emails of new message will be the same as sender email of source message. New message will be added to “OutBox” queue and delivered as all other ones. If ADR is unable to delivery new message (sender email is nonexistent too), then it will be moved into the “Bad” folder.

Integration with Eserv

Eserv (www.eserv.ru) is powerful mail and news server (smtp, pop3, nntp), proxy server (ftp, http, socks5), web server, ftp server and more for Windows 9x/NT. If you have Eserv and ADR at one computer then check this box and Eserv will not break off dial-up connection when ADR is sending the mail, will dial when ADR want to send mail and will disconnect when ADR complete delivery and there are no other processes working with Internet.

Beep when message is moved in “Bad”

Short beep through sound card, not through PC-Speaker, when ADR can’t delivery message and move it in “Bad” folder.

Change icon color when message is moved in “Bad”

The color of ADR icon in system tray will be changed from blue to red when message is moved in “Bad”. The icon become blue again when you open “Bad” folder in Monitor or restart ADR. If message falls in “Bad” when you look this folder then color of icon stay blue.

Beep when all mail will be sent

Short beep through sound card, not through PC-Speaker, when ADR have sent all mail from Outbox folder.

Hand up all dial-up connections when all mail will be sent

Hang up all dial-up connections when the latest message from “OutBox” folder will be sent.

Use message priority in Outbox queue

In this mode ADR tries to deliver messages with the high priority at first, then messages with the normal priority and only then messages with the low priority. New messages with the high priority are put automatically on the begining of Outbox queue and messages with the low priority – on the ending of the queue. Generally mail server don't use a letter priority for its processing, it was added by users request.

Use delay list

Delay list was designed to pass anti-spam filters and was tested with AOL anti-spam filter. But delay list may be useful for other purposes too. Please, see here for details.

Hide splash at program startup

Turn on / off program splash screen.

Setting of Advanced Direct Remailer


Setting of Actions
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Start delivery

The settings of this group give the rules of automatic mail sending start. You also can start mail sending manually through program menu.

Manual through program menu

Don’t use automatic start, start mail sending only manually.

When dial-up connection established

Start sending when dial-up connection is established. If “Any connection” is chosen then start sending when any remote access connection is established. The sending is stopped if connection is broken off.

Automatic

Automatic starts of mail sending as soon as message appears in Outbox folder. For those who have permanent Internet connection.

Purge old mail

The settings of this group allow keeping the messages in “Sent” and “Bad” folders during specified number of days. Older messages will be deleted automatically by ADR.

In Sent box after several last days

Store the messages in “Sent” folder no more than specified number of days. Check option for enable edit window.

In Bad box after several last days

Store the messages in “Bad” folder no more than specified number of days. Check option for enable edit window.

Setting of Advanced Direct Remailer


Setting of DNS
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Primary DNS

Primary DNS-server. It can be given both by domain and by IP-address. Advanced Direct Remailer works with DNS-servers only via UDP protocol. The access time to DNS-servers, which the program uses by default, is 2-3 seconds for some users. Apply to your Internet provider for its DNS-server address, if you want to shorten this period till half a second. Windows can get this information automatically sometimes. And most of providers use this feature to guard user from superfluous settings. ADR tries to determine DNS settings by itself and show them in “Windows DNS Settings”. You can also determine DNS-servers addresses independently using IPCONFIG utility with key /ALL under Windows XP Also you can take DNS addresses from DNS servers list.

Secondary DNS

Secondary DNS-server, it can be empty. It can be given both by domain and by IP-address. It is used only if the primary DNS-server has not answered to the request positively.

Try to delivery by name

Direct delivery. For example, direct delivery to server gorlach.koenig.su for address alex@gorlach.koenig.su. Even if the direct delivery is set, it is used only when DNS-servers have not returned the addresses of mail servers. Using this option IS NOT RECOMMENDED.

Don’t use internal DNS cache

If you have two emails from one domain (e.g. a@hotmail.com and b@hotmail.com) in your mail list, then the program will retrieve addresses of mail servers for second email from its internal cache. You can turn off caching by checking this option.

Windows DNS Settings

Information in this window is updated every second automatically. Program tries to determine DNS settings of Windows by itself and show them in this window. If you have dial-up connection then establish the connection at first in order to ADR can determine DNS settings. You can also determine DNS-servers addresses independently using IPCONFIG utility with key /ALL under Windows NT, or using WINIPCFG utility under Windows 95 or Windows 98. They are utilities of operation system.

Auto update DNS settings

Automatically replace primary and secondary servers by system DNS, if they are found. Settings check and update happen every second. DNS settings not updated when program settings window is opened.

DNS servers list, Setting of Advanced Direct Remailer


Setting of Delivery
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Domain for “HELO”

Your domain for introducing to SMTP-servers. It is recommended to use your real domain. If the domain is not specified, the program tries to determine your domain itself. If it cannot be done for some reason, the domain localhost is used. The use of somebody else's domain or localhost alias is allowed but not recommended - the servers with high security level can refuse to work with you.

If you’re connected to the Internet through Socks5 proxy server, you have to set the proxy server domain manually here – the program can not determine the proxy domain itself.

Delivery threads (0..399)

The number of delivery threads - how many messages will be sent at the same time. By increasing the number of threads you increase the network traffic and computer loading too. It is recommended to use 15...25 threads for 33.6k modem.

Timeout in minutes

The maximum time of waiting in minutes, after expiration of which the message sending is terminated. Set this value to zero to disable it. Count off time from the receiving the latest data from Network.

Delivery only via the most priority SMTP server

By default, if the most priority server is inaccessible for some reason, the program tries to send message through the servers with lower priority which were found in DNS for this address. This setting instructs the program to send messages only through the most priority server and, if this server is down, don't try other servers (with lower priority).

Auto delivery letter via ISP

If the given number of attempts to deliver a letter directly is failed then this letter is sent via ISP automatically. This mode is more suitable than the manual switching to “Delivery via ISP” mode.

Internet Service Provider SMTP Settings

In Monitor menu (“Delivery” -> “Delivery via ISP”) you can switch mail direct delivery (from your computer to recipient mail server) to delivery through Internet Service Provider (ISP) outgoing mail server, this server also is called SMTP server. It’s may be useful, when mail servers of your recipients temporarily down, and your computer have not permanent connection with Internet.

SMTP server of ISP

Outgoing mail server (SMTP) of your service provider. May be either domain or IP-address. Examples: smtp.isp.com, 195.2.83.112. First feature: if the name of ISP SMTP server is NULL (for programmers: it is string, not pointer ;-), then message delivered via ISP will moved in “Bad” folder. For example, together with “Auto delivery letter via ISP” you can drop messages which was not delivered by several attempts; together with delay list you will be able to block some email domains. Second feature: you can set a number of ISP SMTP servers trough comma (e.g., “smtp.isp.com, mx1.isp.com, mx2.isp.com”). Note, that all servers must have the same TCP port, username and password.

Port of ISP SMTP server

Server TCP port. Usually, it is 25. Don’t confuse SMTP with POP3 or NNTP servers, which are on 110 and 119 ports by default.

Use authentication for SMTP server

By default, SMTP servers not require authentication, unlike POP3 servers. ADR support only PLAIN and LOGIN authentication types for SMTP, other schemes are not implemented for now.

Login for ISP SMTP server

Login or username for SMTP server. Check “Use authentication” box to make this item enable.

Password for ISP SMTP server

Password for ISP SMTP server. Check “Use authentication” box to make this item enable.

Setting of Advanced Direct Remailer


Setting of internal SMTP server

EMMA Labs web site

Navigation: Program settings:

Setting of internal mail server
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Internal mail server (SMTP) receives messages from mail programs and stand them in outcoming mail queue OutBox. See “Server and mail boxes” chapter to know more.

Server TCP Port

By default server is on 25 TCP-port. Don’t change the number of this port. If you change this setting then you must correct settings of your mailer too.

Allowed IPs

The masks of IP addresses which allow connecting with internal mail server. Set *.*.*.* mask if you want to allow that any computer in Internet can connect with your server and send mail through it. Set 10.1.1.* mask if you have LAN with addresses in range 10.1.1.1-10.1.1.255. You can enumerate several masks by commas, e.g. 127.0.0.1, 10.*.*.*. 127.0.0.1 is the IP address of your local computer; this address can’t be used to access to your computer from any remote computer, because it point to local machine at any machine.

Bind Address

You can specify one network interface for incoming connections. E.g., if you’ll specify 127.0.0.1 interface, then only connections from local computer will accepted. IP’s masks is more flexible solution to prevent hackers attacks, but in this case it is possible to run several different SMTP servers (by one on each network interface). If this field blank, then connections will accepted on all available interfaces.

Local Domain

Local domain of mail server, it’s recommended to replace it by your mail domain. Mail server will stand in outcoming mail queue all messages, which were sent to another domain. If you replace server domain by elcomsoft.com, then you must send message to maillist@elcomsoft.com address in order that your message get to maillist local box.

X-Server Kludge

The contents of X-Server line added to title of each message. If the line isn’t input then the kludge will be not added to message.

Set recipient email in “To:” field

Usually when you send message to mail list in “To:” field there is the address of mail list. ADR can replace this address by address of real message recipient. If mail list is CSV file then ADR substitute only recipient email. If mail list is LST or TXT file then ADR substitute WHOLE LINE with email. Look at mail list formats for details.

Detailed server log

To keep more detailed log of internal mail server working. When this option is turned on the SMTP commands will be registered in the log.

Use authentication for access to server

Set login and password for access to internal mail server. Recommended to use them for protection against hacker's invasion. ADR supports such authentication schemes as PLAIN (used by Netscape Messenger) and LOGIN (described in RFC 2554, used by Microsoft Outlook, Microsoft Outlook Express and TheBat!).

Enable EXPN command

This SMTP server’s command allow to get list of emails by mailing list name. E.g., TELNET session with request of emails from “simple” mailbox (mailbox created when you install ADR):

220 Advanced Direct Remailer ESMTP is Ready

expn simple

220-recycled1@pisem.net

220-recycled2@pisem.net

220-recycled3@pisem.net

220-recycled4@pisem.net

220 recycled5@pisem.net

quit

221 Service closing transmission channel

ADR also have four virtual mailboxes: @outbox, @sent, @bad и @stat. On request of @outbox you’ll get recipients of all messages in ADR Outbox and so on. On request of @stat you’ll get general ADR statistic:

220 Advanced Direct Remailer ESMTP is Ready

expn @stat

220-Outbox: 0

220-Sent: 41

220-Bad: 0

220-In delivery: 0

220 State: delivery stopped

quit

221 Service closing transmission channel

By default, EXPN command is turned off for security reasons.

Setting of Advanced Direct Remailer


Setting of Mailboxes
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Internal mail server (SMTP) receives messages from mail programs and stand them in outcoming mail queue OutBox. Internal mail server realizes the connection between mail program and ADR. In addition to this function it have another important one – the support of mail lists. See “Server and mail boxes” chapter to know more.

You can add and delete mail boxes, add mail lists and user processing programs (plugins) to boxes using toolbar or clicking by right mouse button on items tree.

During installation the program creates several examples of mailboxes.

Setting of Advanced Direct Remailer


Setting of Proxy
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Connection through Socks5-proxy server

Proxy server is a special program, which allows LAN users to work with Internet (when only one machine has the “real” IP address). Please contact your network administrator if you’re not sure how you’re connected, and how to set appropriate options here. Such popular program as ICQ works in LAN using Socks5 protocol. You must indicate proxy-server domain in setting of delivery if you use proxy-server.

Address

Proxy-server address. May be either domain or IP-address. Examples: proxy.isp.com, 10.1.1.1.

Port

Server port. Usually, it is 1080. Don’t confuse Socks5 proxy with http and ftp proxies, which are on 3128 and 3121 ports by default. The program doesn’t work through http or ftp proxies.

Use RFC 1929 authentication (clear-text)

The server requires authentication, i.e. requires user login and password. In most Socks5 realizations, the login and password are transferred as a plain text, as described in RFC 1929 document.

Login

The name (login) of Socks5 proxy server user.

Password

The password for Socks5 proxy server user.

Use mapping for DNS

Use port mapping to work with DNS using UDP protocol. Some proxy-server realizations, for example WinGate 3.0, work incorrectly using UDP protocol, and in that case it is necessary to use such mapping. For example, if your proxy-server has an address 10.1.1.1, then map 53 UDP-port of the first DNS, e.g. ns.ml.org, to 53 local port, and the port of the second DNS – to 54 local port. In DNS setting, indicate these addresses as 10.1.1.1 and 10.1.1.1:54 (port 53 is used by default).

Setting of Advanced Direct Remailer


Setting of Logs
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Keep entries only for several last days

ADR supports an automatic cutting of program logs (not a message log!), which are in \log directory. ADR cuts the program logs once every day keeping the records only for given number of days. ADR keeps the following seven program logs:

GENERAL – with general information about system functioning (operation);

SERVER – internal SMTP-server log, message receiving;

TOSSER –information about received message processing;

MAILER – log about message delivery process and queues conditions;

SQL – log with information about SOL mailing lists;

WAB – log with information about working with Windows Address Books;

ERROR – service information about system internal errors.

It’s recommended to use the log cutting for saving disk space.

Store in message log only the latest record

Store in message logs only the latest record. If the message can’t be sent, his log can go up (swell) several tens of kilobytes during the night that can result in shortage of disk space.

Turn off all program logs

To turn off all program logs (but not the message logs). It may be useful for frequent (several times a day) and great delivery to save the disk space.

Turn off all message logs

Turn off all message logs, not program logs. Message log contains information about message delivery and is stored in \mail\log subdirectory of Advanced Direct Remailer.

Store events time in message log

For each line, the time when it was received is stored in message log. It is useful to find source of problems with speed of mail delivery.

Log viewer

The external program is used for program log viewing. You can run it through Log menu of Monitor window. There you must set the path to viewer and log file name will be transmitted in command line to this viewer. Or you can find executable file of viewer using “Open…” button. The default viewer is Notepad (Notepad.exe).

Setting of Advanced Direct Remailer


Mail program setting
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

There is only one setting in mail program you will have to change – it is address of outcoming mail server (SMTP). Mail program receives mail from mail server works using POP3 protocol and send your messages through server works using SMTP protocol. Don’t change address of incoming mail server (POP3) because you are continue to receive mail through your provider server.

If you have installed ADR on your computer then the new address of mail server is localhost or 127.0.0.1. If you have installed ADR on computer in LAN, e. g. with address 10.1.1.1, then the new address of mail server is 10.1.1.1. For all examples below we’ll consider that you have installed the program on your computer and will use address - 127.0.0.1

Usually, mail program setting present no difficulty and takes a few minutes. It is supposed that your mail program is already configured for working with mail and so in program setting are described only those changes which are necessary for working with ADR. Otherwise, configure the program for working through provider mail server at first and only then execute changes given below.

Setting of Microsoft Outlook Express, Setting of The Bat, Setting of Netscape Messenger


Setting of Microsoft Outlook Express

EMMA Labs web site

Navigation: Configuring mail clients:

Setting of Outlook Express
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Here is given the description of Outlook Express 5.0 setting, the setting of previous versions don’t differ. Check "Accounts..." item in "Tools" menu. Check "Mail" tub in appear "Internet Accounts" window (see the picture).

Check account which you want to configure for working with ADR and press "Properties" button. If you have a number of accounts for mail and want to configure they all for working with ADR then you have to execute the following operation several times. Check "Servers" tub in appear "account name Properties" window. Replace "Outgoing mail (SMTP)" address for localhost (see picture below). Press "Apply" button and that is all! Now you can send test message from configured account.

Notes:

1.If you replace TCP port of ADR server from 25 to any other, then change port number of SMTP server on "Advanced" tab.

2.If you use SSL protected connection with SMTP server then switch off corresponding checkbox on "Advanced" tab. ADR doesn’t support protected connection.

Mail program setting


Setting of The Bat
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Version 1.34 is taken as example for description of The Bat setting. Choose account you want to configure and check "Properties..." item in "Account" menu. Select "Transport" section of settings in appear "Edit User – User Name" window as shown in picture. If you want to configure all accounts for working through ADR you have to execute the following operation several times.

Change "SMTP Server" field to localhost. Press "OK" button and that is all! Now you can send the test message from configured account.

Notes:

1.If you replace TCP port of ADR server from 25 to any other then change port number of SMTP server in "Mail management" section of setting.

2.If you use the authentication for working with SMTP server then press "More..." button in "Transport" section of setting and switch off it. ADR doesn’t require the authentication.

Mail program setting


Setting of Mozilla Thunderbird
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The description of program setting is given on basis of version 17.0 Choose "Preferences..." item in "Edit" menu. Select "Mail & Newsgroups -> Mail Servers" branch in appear "Preferences" window as shown in picture. Replace "Outgoing mail (SMTP) server" value by 127.0.0.1 Press "OK" button and that is all! Now you can send the test message.

Notes:

1.If you replace TCP port of ADR server from 25 by any other, e. g. 26, then point port by colon - localhost:26.

2.If you use SSL or TSL protected connection then you must switch off protection by choose "Never" as shown in picture. ADR doesn’t support protected connection.

Mail program setting


Introduction

EMMA Labs web site

Navigation: Information for programmers:

Information for programmers
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

ADR provides a programmer with two powerful opportunities - an opportunity to organize mail delivery without going deep into special aspects of socket programming, and an opportunity to create new message processing programs (plugins).

· Simple messages generation for ADR

· Plugins system

Since version 2.0, ADR has COM interface. COM is the fundamental "object model" on which ActiveX Controls and OLE are built. COM allows an object to expose its functionality to other components and to host applications. It defines both how the object exposes itself and how this exposure works across processes and across networks. Now, you can use Advanced Direct Remailer power with any programming language and with any software, which supports COM.

So, you can work with ADR from Microsoft Visual C++, Borland Delphi, CBuilder, and Microsoft Visual Basic and from many other developer envelopments. You can send messages through ADR from server side scripts in ASP (Active Server Pages, Microsoft Technology) and ColdFusion web pages and you can work with ADR service on remote computer via DCOM (Distributed COM Service). You can call local ADR copy from JavaScript and VBScript codes and so on! You can do everything!

· IAdrMessage interface

· Methods of IAdrMessage

· Typical program code

· Code samples

Mailing list formats


Simple messages generation for ADR

EMMA Labs web site

Navigation: Information for programmers:

Simple messages generation
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Your program can merely generate text files with messages and put them in MAIL\OUT directory, so that Advanced Direct Remailer send them. Messages format is the following:

>>> you@yourisp.com

<<< recipient@recipient.com

From: "You" <you@yourisp.com>

To: <recipient@recipient.com>

Subject: TEST!

Dear Recipient, it is test !

.

The first line contains sender's address, the second line contains recipient's address. An empty line is followed by the message thread ending with full stop and CRLF. It is recommended to view outgoing messages in MAIL\OUT directory to learn what else fields mail programs add to a message heading and find out more details about messages format.

After your program has generated the message, you need ADR to reread the OUT directory to add the messages into the outgoing queue. ADR doesn't do this constantly, as scanning the directory might take tens of seconds and result in heavy loading of the system due to intense work with the disk. There are three possible ways to scan the directory:

1.To relaunch ADR

2.To run the program Utils\Sync\Sync.exe

3.To send a message to the ADR window.

When the ADR window receives the message WM_USER+5, OUT directory is rescanned. Sync.exe ensures rescanning of OUT directory by sending the same message. You can view its text in the file Utils\Sync\Sync.c, it contains just a few lines.

If ADR is configured so that mail sending can be started only manually, you also can send the message WM_USER+6 to the ADR window to have ADR started sending mail, or to run the program Utils\Mailing\Mailing.exe, its source code is also contained in that directory. WM_USER+7 and WM_USER+8 messages cause pause and stop delivery. This functionality is implemented in Pauze.exe and Stop.exe, this programs and their codes are placed into Utils directory. Any your suggestions to develop Advanced Direct Remailer API are welcomed.

Information for programmers


Plugins system
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

You can find out more details about ideology of user's mail processing programs (plugins) in the article "Internal SMTP server and mailboxes". Plugin is a program or a batch file launched to process the message. Full name of the file is communicated to plugin as the first argument in the command line. Plugin can modify the message any way it decides to, or even delete it if necessary.

Most the plugins enclosed with Advanced Direct Remailer have source code in C or Delphi. You can study them and modify as you find necessary.

Plugins for ADR can be written in any programming language, they can be GUI or console applications or even batch files. When creating plugins one should take into account that plugin is launched repeatedly to process each message, and processing of another message will not start until processing of the previous message is finished.

About DLL versions of plugins, Internal SMTP server and mailboxes, Information for programmers


IAdrMessage interface
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

IAdrMessage interface of “Advanced Direct Remailer Component 1.1” component allows to transmit letters for future delivery by ADR. Actually, ADR can receive messages by three ways now:

· Through internal SMTP server

· Through files created on disk

·Through COM/ActiveX interface

IAdrMessage is dual-interface. So, you can use ADR service through disp-interface (Visual Basic, JavaScript, ASP) or through vtbl-interface (Microsoft Visual C++, Borland Delphi). The ADR package includes code examples for both methods.

Standard C++ header for interface is in file:

COM\Amv_MFC\adr_h.h

of Advanced Direct Remailer subdirectory.

Interface methods, Typical program code, Code samples


Methods of IAdrMessage
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

virtual /* [propput] */ HRESULT __stdcall put_Kludges( /* [in] */ BSTR bstrKludges);

This method is optional for calling. It adds the lines with technical information (kludges) to message headline. Each line must end with CRLF sequence (line feed, characters with 13 and 10 codes).

Examples:

X-Mailer: MyApplication

X-Mailer-Version: 1.0

The returned value is S_OK. If memory is not enough to store transmitted value, the returned code will be E_FAIL.

virtual /* [propput] */ HRESULT __stdcall put_From( /* [in] */ BSTR bstrEmail);

Setting the address of message sender. You can specify address in any known format, e.g.:

support@elcomsoft.com

Support <support@elcomsoft.com>

“Alex Gorlach” <gorlach@mailutilities.com>

The returned value is S_OK. If memory is not enough to store transmitted value, the returned code will be E_FAIL. This function doesn't check the address syntax. The Send method checks the correctness of specified values (see below).

virtual /* [propput] */ HRESULT __stdcall put_To( /* [in] */ BSTR bstrEmail);

Setting the address of message recipient. You can specify address in any known format, e.g.:

support@soft.com

Support <support@soft.com>

“Alex Gorlach” <gorlach@mail.com>

The returned value is S_OK. If memory is not enough to store transmitted value, the returned code will be E_FAIL. This function doesn't check the address syntax. The Send method checks the correctness of specified values (see below). You can specify only one address of recipient. If you want to send message to several recipients, it’s necessary to specify recipient and call Send the respective number of times.

virtual /* [propput] */ HRESULT __stdcall put_Subject( /* [in] */ BSTR bstrSubject);

This method is optional for calling. Setting of message “Subject” field. Note, that this string will be placed into the message as is. You must make message encoding yourself, if it is required. The returned value is S_OK. If memory is not enough to store transmitted value, the returned code will be E_FAIL.

virtual /* [propput] */ HRESULT __stdcall put_Body( /* [in] */ BSTR bstrBody);

This method is optional for calling. Setting the message body. Note, that this string will be placed into the message as is. You must make message encoding yourself, if it is required. The message size is not limited. The returned value is S_OK. If memory is not enough to store transmitted value, the returned code will be E_FAIL.

virtual HRESULT __stdcall Reset( void);

This method is optional for calling. Reset all values that are assigned by functions mentioned above. The returned value is S_OK.

virtual HRESULT __stdcall Send( void);

Sending the message. Before call this method, assign message “To“ and “From” fields, the rest fields may be null. The sending doesn’t cause a reset of assigned values (for that there is the Reset() method). Two successive Send() call will send two identical copies of message (only with different values in “Date” field). If you wish to delivery message by list of addresses, then you must fill all message fields once, and then call pairs put_To() – Send() for each recipient.

Returned values:

S_OK – message was successfully sent;

S_FALSE – some error happen.

In second case, you may call get_LastError() method to know the reason of failure (see below).

virtual /* [propget] */ HRESULT __stdcall get_LastError(/* [retval][out] */ long __RPC_FAR *lCode);

This method is optional for calling. Store result code of the last Send() method call into the given variable. The possible values are:

CAE_NO_ERROR (code is 0) – there were no Send() calls, or message was successfully sent during the last call;

CAE_INAVLID_SENDER (1) – wrong email of message sender, or sender email was not set before Send() method call;

CAE_INAVLID_RECIPIENT (2) – wrong email of message recipient, or recipient email was not set before Send() method call;

CAE_FILE_ERROR (3) – error happen during saving message on disk by ADR (information about such errors also stored into ADR error log);

CAE_NO_MEMORY (4) – not enough memory during message sending.

Number of error codes may be increased in future ADR versions. All codes larger than CAE_NO_MEMORY (lCode = 4) must be processed by application as “unknown error”. Returned value is S_OK.

Typical program code


Typical program code
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

var msg, result;

msg = new ActiveXObject('AdvancedDirectRemailer.AdrMessage');

msg.From = ‘Alexander Gorlach <gorlach@mailutilities.com>';

msg.To = ‘Vladimir Katalov <vkatalov@elcomsoft.com>';

msg.Subject = ‘Sorry, it is test!’;

msg.Body = ‘Hello!\r\nIt is test…’;

msg.Kludges = 'X-Source: web mail\r\nX-Form: AdrMsg.html\r\n';

msg.Send();

switch (msg.LastError)

{

case 0: result = "Message was successfully sent"; break;

case 1: result = "Invalid sender email"; break;

case 2: result = "Invalid recipient email"; break;

case 3: result = "File read/write error"; break;

case 4: result = "Not enough memory"; break;

default: result = "Unknown error";

}

Code samples


Control and configuration interfaces
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Eight new COM/ActiveX interfaces has been added to version 2.12 to control and configure Advanced Direct Remailer from other applications. Seven interfaces provide access to appropriate tabs of settings:

IAdrGeneral - to properties of a tab "General".

IAdrActions - to properties of a tab "Actions".

IAdrDns - to properties of a tab "DNS".

IAdrDelivery - to properties of a tab "Delivery".

IAdrServer - to properties of a tab "Server".

IAdrProxy - to properties of a tab "Proxy".

IAdrLogs - to properties of a tab "Logs".

Through interfaces it is impossible to get access only to a tab "Mailboxes" of settings. The eighth interface - IAdrControl - provides Advanced Direct Remailer control capabilities. With methods of this interface it is possible to control delivery (to start, stop, route stream of mail through the ISP), control the SMTP-server of the program, reload settings of the program from the Windows registry and to save them, to resynchronize Outbox, to get a state of the program and other. Look example AdrCntr of usage of these interfaces. Methods of interfaces can be learned through the type library of component or the adr_h.h header file, which is supplied with AdrVc sample.

Code samples


Code samples
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

You can find some examples with complete source codes in COM subdirectory of the directory with ADR. Note, that running of some examples (especially, example 5) can require the configuration of access rights to “Advanced Direct Remailer Component 1.1” component. You can do that with DCOMCNFG.EXE utility of operating system. In general, if ADR has been started as usual application (not as Windows NT service) then running of 1..4 and 6 examples don’t require any settings.

1.AdrVB6 - example of Microsoft Visual Basic 6 application.

2.AdrVC – example of Microsoft Visual C++ 6 application, pure Win32 API.

3.AdrDelphi3 – example of Borland Delphi v3 application.

4.AdrMsg.html – example of JavaScript client-side script. Require Microsoft Internet Explorer 3.0 or above.

5.AdrMsg.asp - ASP server-side script example (Active Server Pages, Microsoft Technology) for Microsoft IIS web-server.

6.AdrCntr - example for control and configuration interfaces (Microsoft Visual Basic 6).

Typical program code


Mail folders moving
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

By default, the folders with messages (Outbox, Sent, Bad) are in subdirectory of Advanced Direct Remailer. You can carry these and other folders to another directory of disk setting the paths to them in HKEY_LOCAL_MACHINE\Software\MailUtilities\Advanced Direct Remailer section of Windows registry. Pay attention that any path must have slash (\) on its end and be existent. The parameters are:

@SystemLogFolder – the folder where ADR keeps the working logs, by default this folder is \logs subdirectory in the directory with Advanced Direct Remailer.

@MailFolder – the subdirectory \mail, where the directories for Outbox folder (\mail\out) and Sent folder (\mail\sent) and etc. are created. Changing this parameter you carry at once the whole hierarchy of folders. You can carry folders separately setting the following parameters.

@OutboxFolder – the directory with outgoing messages, Outbox folder (\mail\out).

@SentFolder – the directory with the sent messages, Sent folder (\mail\sent).

@BadboxFolder – the directory with Bad folder (\mail\bad).

@SpoolFolder – the special directory of message tosser (\mail\spool).

@LogFolder – the directory with logs of message sending (\mail\log).

To return these folders to its previous place just delete the given parameters from Windows registry.

Information for programmers


SMTP codes settings
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Some SMTP servers process message body and may reject message after message body transfer (after DATA command). In RFC 821 following codes was declared for this situation:

552 Requested mail action aborted: exceeded storage allocation

554 Transaction failed

451 Requested action aborted: error in processing

452 Requested action not taken: insufficient system storage

And all of this replies is not mean that there no chances to delivery message. And ADR will try deliver message again and again. In version 1.42 registry DWORD variable DataBreakCode was added. This variable is not set by default. Low and high words of this variable contain SMTP server answer codes on which ADR will move message in “Bad” folder. Note, that this variable contain codes for DATA command only.

Information for programmers


Other settings
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Some ADR settings can be set only through registry. All keys described below must be located in HKEY_LOCAL_MACHINE\Software\Elcom\Advanced Direct Remailer section of Windows registry. The keys come in effect after ADR restart. To cancel key’s effect, you have to delete them from registry and restart ADR.

CsvDelimeter key

The type of this key is STRING. If this key is set, then ADR use the fist sign of string as separator in CSV files. Otherwise, it use the sign specified in system regional settings.

SafeSockRead key

The type is DWORD. Some mail clients have wrong SMTP client realization, they send a few commands to ADR internal mail server without waiting its answers (e.g., Bounce Spam Mail v1.8). If this key is set in 1, ADR works with mail clients more “carefully” (but and more slowly too). As now we know only one program, which require turning on this setting.

ServerAuthUseLogin key

The type is DWORD. The choice of authentication scheme for working with Internet Service Provider mail server. Mail server, which use authentication, have to inform mail client about supported authentication types. If server doesn’t inform about supported schemes, but authentication is required, ADR use PLAIN scheme by default. Set this parameter in 1 and ADR will use LOGIN scheme by default.

MailOkWav key

The type is STRING. Set full path to WAV sound file which will be played instead of standard sound when all messagess will be send (if respective option Is turned on at “General” tab).

MailBadWav key

The type is STRING. Set full path to WAV sound file which will be played instead of standard sound when one from messages fall into “Bad” folder (if respective option is turned on at “General” tab).

HELOCmd key

Command to greet remote server. You may set HELO or EHLO, EHLO is used by default. Also, you may set full greeting here, e.g. “HELO mydomain.com”. This key is re-checked on every time, when ADR delivery message.

Mail folders moving, SMTP codes settings


AdrSplit utility
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The maximal number of addresses in the mailing list is 100000. If your lists are longer, divide them into parts by this utility. AdrSplit is placed in the subdirectory Utils with Advanced Direct Remailer.

Syntax:

ADRSPLIT.EXE lines input_file

Where lines is the maximum number of lines in output files, input_file is the list you want to split. The output files are saved in the directory with the input file and have names like input_file.NNN, where NNN is the number of a part.

Examples:

ADRSPLIT.EXE 1000 my.lst

ADRSPLIT.EXE 10000 “C:\Program Files\Eserv\forward.lst”

To concatenate the parts back to one file, use the COPY command in a command line. For example:

COPY my.lst.001+my.lst.002+my.lst.003 my_checked.lst

COPY my.lst.0?? my_checked.lst

AdrNoDup utility, Program overview


AdrNoDup utility
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

This program is designed to delete duplicated emails in mailing list. AdrNoDup is placed in the subdirectory Utils with Advanced Direct Remailer.

Syntax:

ADRNODUP.EXE infile outfile

Where infile is the source mail list file, outfile is the output file name.

Examples:

ADRNODUP.EXE customers.lst cust_clean.lst

ADRNODUP.EXE "C:\Program Files\My List.txt" mylst.txt

AdrSplit utility, Program overview


TestDLL utility
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

This utility is intended for programmers. You can test DLL-plugins by it without Advanced Direct Remailer.

Syntax:

TestDLL.EXE plugin.dll File1.msg [File2.msg … [FileN.msg]]

Where:

Plugin.dll – plugin in test;

File1.msg – file with message in ADR format.

Examples:

TestDLL.EXE sendnum.dll 111ix5l-000-0000.msg

TestDLL.EXE msgid.dll 1.msg 2.msg 3.msg 4.msg

The program loades plugin for test by ADR method and processes specified files with messages by it. The utility with its source code is placed in utils subdirectory.

About DLL versions of plugins


How to register

EMMA Labs web site

Navigation: Registration:

Registration
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

You can register your copy of ADR via RegNow registration service using any major credit card. You can register on-line, using fax, toll-free phone, by check or wire transfer. Money orders are also accepted.

On the Internet, go to our Web page at: http://www.mailutilities.com/purchase/ and follow the link "Purchase ADR".

You can also use the wire transfer to register ADR. Please contact EMMA Labs. for more details.

On payment approval, we'll send you the registration key, which will remove the nag screen in Advanced Direct Remailer and enable some additional features. Your registration will be valid for all future versions of ADR.

See also: Program support


Unregistered copy limitations

EMMA Labs web site

Navigation: Registration:

Unregistred copy limitations
No contents entries on this page
Contents
Topic functions menu
Menu
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The unregistered version of ADR is fully functional. Anyone may use this software during a test period of 30 days. Following this test period of 30 days or less, if you wish to continue to use ADR, you MUST register.

You can free try program within 30 days trial period. Also, we can provide only limited support (and with low priority) to unregistered users.

When you’ll register, you’ll get the registration key (serial number) which will remove unregistered copy limitation. Your registration key will work for all future versions of ADR (or we may provide you with the new key, if the keys will be changed for some reason).

Program registration, Program support


Web Server
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

On the web-site you can find the complete list of our software products and the latest news, download trial versions of the products, and register your software.

· Advanced Email Extractor

· Mailing List Wizard

· Advanced Direct Remailer

· High Speed Verifier

Most of our products are being updated once a month on the average. Don't forget to visit our site, we are always glad to see you! Should you have any questions or suggestions, please, contact the technical support service.


Program support
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Before you contact us, please do the following:

·Be sure that you’re doing everything right. We all make mistakes sometimes... Be attentive.

·Look at the Help file: it may already contain an answer to your question. A lot of people ask us something like "how do I…", though the complete information is there (in the document you’re reading now).

·Visit ADR home page in the Internet at http://www.emmalabs.com/adr/. It’s a good chance that you’ll find the newer version of ADR there; we’re trying to update the program once a month or even more frequently – when our staff is not on vacations, of course. Also, if the serious bug has been found in the program, but the new version is not ready yet, we make the hot fix for it.

But if you still have a problem with ADR and noting else helps, please contact technical support staff at:

http://www.emmalabs.com/support/

Please inform us about the following:

·Advanced Direct Remailer version (from About dialog)

·Advanced Direct Remailer registration code or user ID (if you're a registered user) – this will help us to process your request faster

·where did you get Advanced Direct Remailer (http or ftp site)

·Windows version (including service packs and other fixes installed), US or international, OEM or not

·computer information: CPU type and speed, amount of memory installed

·description of your problem (as much information as possible to retrieve the problem)

·any additional information, which may help: DNS and SMTP settings, etc.

We’ll try to help you as fast as possible, usually in one or two business days.

If you have any comments or suggestions for the next releases, please feel free to post them to us.


Advanced Email Extractor
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Advanced Email Extractor 3 (EmEx 3) is designed to extract e-mail addresses from web-pages on the Internet (using HTTP and HTTPS protocols) and from HTML and text files on local disks. EmEx 3 supports operation through a proxy-server and works very fast, as it is able of loading several pages simultaneously, and requires very few resources.

EmEx 3 is intended to collect information (e-mail addresses, phone numbers, ICQ/MSN/Skupe UINs and many others) from public sources in Internet.

The most common issues, which appeared in our other smart solution - Advanced Email Extractor (AEE), were solved in EmEx 3. Also, we took into account the newest technologies of email addresses protection from extracting and collection.

The software interface is more simple and handy and program's features are almost unlimited.

More 300 search engines over whole world can process your queries now. We constantly track the actuality of script databases for processing of search engines results, so you don't need to update the software if a search engine changes the format of data. You will get the updated settings with every run of EmEx 3.

Take a look to a short list of EmEx 3 features:

·Data search in different sources including search engines

·Support of more than 300 search engines (including Yahoo, Google, MSN)

·Simplified HTTP authorization on such websites as web forums or paid services

·Search limitations: by country, domain, document code page

·Customizable list of exceptions

·Black and white lists

·List of ignored domains

·Filter by keywords with support of logical expressions

·Anti-flood filter to regulate load on scanned websites (anti-hammer);

·Scheduler

·Dynamic replacement of document's content

·Masking by User-Agent

·Filters by MIME-types of the scanned document

·Mode of multi thread scanning which enables to process up to 50 documents at once

·Limitation of loading speed

·Daily updated script schemes for information recognition

·Proxy support

·Daily updated lists of proxy servers

·An ability to form non standard search templates without updating the application

·and much more!

EmEx 3 works under Vista/Windows 7/8 with Microsoft Internet Explorer 8.0 or higher installed. It will never go out-of-date - it will become better and better, it's capabilities will expand with every new release of Internet Explorer.

You can download program free from our site.


Introduction
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

This program is intended for e-mail addresses and mail lists verifying. The main task is to determine which of addresses in the mail list are dead. The program is oriented, basically, on programmers which have their own mail lists to inform their users about new versions of their programs.

For example, there are about 850 emails in your mail list. About hundred of them are dead. The user can change his Internet Service Provider (ISP) and his own e-mail address. The dead addresses don’t allow to determine the correct number of subscribers, and interfere with mail system working. After sending 850 messages you loose your time receiving hundred of your messages back with remark: “beg pardon, but such address not exist”.

The program works using the same algorithm as ISP mail systems do. Mail servers addresses for specified address are extracted from DNS. The program tries to connect with found SMTP-servers and simulates sending the message. It does not come to the message sending - AMV disconnect as soon as mail server informs does this address exist or not.

AMV can find about 90% of dead addresses - some mail systems receive all messages and only then see their addresses and if the address is dead send the message back with remark about it.

The program is multi-threaded; that provides the high speed of checking and allows to regulate the network traffic and your machine loading. AMV is for network administrators and experienced users - we hope that the program is powerful, simple and convenient.


High Speed Verifier
No contents entries on this page
Go to previous topic
Go to home topic
Go to next topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

High Speed Verifier (HSV) is a high-speed software designed to check e-mail address for existence. HSV is capable of checking thousands of addresses per second. It can easily deal with mailing lists containing tens millions of addresses; moreover, it is with this list size that the program's highest performance can be achieved.

HSV detects about 20-30% of invalid addresses in a mailing list, though theoretically it is possible to detect up to 60-70% using a software product. This figure seems relatively small, but actually it might make 10% of a list. Besides, HSV provides for optimal checking mode in terms of time and data traffic. More thorough checking (with which the rest 40% of invalid addresses could be detected) takes 10 times longer and requires 5 times greater traffic for each address, hence it's not that advisable with huge lists.

We are pleased to offer you two software products designed to check e-mail addresses for existence — Advanced Maillist Verify (AMV), which does the two-phase checking (DNS and SMTP) and detect all possible dead emails, and High Speed Verifier (HSV), which only performs the first phase (DNS).

AMV is helpful when you need to thoroughly check relatively small mailing lists (containing no more than 50..100 thousand addresses). Advanced Maillist Verify is also capable of checking addresses in databases, address books of popular applications, it has COM/ActiveX interfaces for integration into various software systems and CGI/ISAPI modules for simpler integration into wed-servers. However, technical principles underlying AMV interface solutions don't allow using it for longer lists.

High Speed Verifier is offered as a solution for quick removal of garbage from lists with millions of addresses. For purely technical reasons, its operating rate is 10..15 times greater than that of AMV with relatively small lists, and with lists containing millions of addresses the difference in operating rate might be up to thousands of times. Growth of the HSV operating rate with longer lists is ensured by the fact that HSV stores the results of all queries to DNS servers in RAM cache, so, with longer lists the rate of cache hits is greater.

HSV is the first professional software designed to check huge mailing lists, it is created by professionals for professionals. We hope with HSV your business will be more effective and successful, and you will enjoy using our product.

You can download program free from our site.


Mailing List Wizard
No contents entries on this page
Go to previous topic
Go to home topic
This is the last topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Mailing List Wizard (MLW) is designed to help you with processing and converting your mailing lists. It is able of excluding duplicated addresses, correcting misspelled addresses using unique algorithms, filtering lists by varied criteria, merging lists, and making exclusions from address lists using an additional list. MLW can supplement mailing lists with address owner names using information from other lists, delete address owner names from mailing lists, sort emails in mailing lists, and also many other things. MLW is a single software product that combines functions of several programs for mailing list processing.

The program works in a wizard mode: it will prompt you step by step to choose action type; to choose a file the action is to be taken upon (source file); to choose a file the results to be saved into (destination file); to choose action settings and to specify additional files to be involved in the action.

When an operation is being performed, the results are stored in a temporary file on disk, and they are moved to the destination file only after the action is successfully completed. This allows interrupting an action in any phase without a risk of losing data any changes to files involved in the action are made only upon its completion. The temporary file is created in the same directory where the destination file is to be stored. Therefore, you need to have enough of free space on your disk so the temporary file could be saved.

During an action, the program is displaying a real-time log showing the action progress. For example, when exclusion of duplicated addresses is being performed, all the duplicated addresses found will be written to the log along with line numbers. Besides, the log contains statistic information such as number of lines processed, action execution time, etc. When processing large mailing lists, the number of entries in the log might exceed 100000, and refreshing the log on the screen might take system resources comparable to resources needed for the list processing itself. Therefore only first 60 K of the log are displayed real-time (about 1500 lines).

The whole log is stored in a temporary file in the MLW directory. After the action is completed, you can save the log from temporary file to any other file, open and view it with a text editor. You can also choose the option "Statistics only in this window" if you want only important information and statistics to be shown real-time (total about 5-20 lines during an action).

You can download program free from our site.


Comma separated values (.CSV) lists
No contents entries on this page
This is the first topic
Go to home topic
This is the last topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

CSV format (Comma Separated Values, *.csv). It has been made specially for Outlook Express users - you can export all address book to the CSV file. In CSV-files, only first address of e-mail in line is used. ADR use list separator character which is specified in regional settings of operating system. Also you can override this setting through ADR registry.

Since 1.4 version of ADR the support of Windows address books was added and now Outlook Express users may realize the delivery by address book. But not only Outlook has the possibility to export its data to CSV format. For example, MS Excel spreadsheet can be exported to CSV format.

Mailing list formats


DNS servers list
No contents entries on this page
This is the first topic
Go to home topic
This is the last topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

The access time to DNS-servers, which the program uses by default, is 2-3 seconds for some users. Apply to your Internet provider for its DNS-server address, if you want to shorten this period till half a second. Program tries to determine DNS settings by itself and show them in "Windows DNS Settings" at "DNS" tab in general settings. You can also determine DNS-servers addresses independently using IPCONFIG utility with key /ALL under Windows NT, or using WINIPCFG utility under Windows 95 or Windows 98. They are utilities of operation system.

Also you can use DNS servers from this list if you can't get your provider DNS address for some reason or your provider server works unstably.

ns.worldnet.att.net                                                 AT&T-WorldNet (USA, www.worldnet.att.net)

nameserver.concentric.net                                 Concentric (USA, www.concentric.net)

arl-name-svc-1.compuserve.com                 CompuServe (USA, www.aol.com)

ns.psi.net                                                                 PSInet (USA, www.psi.net)

dns1.sympatico.ca                                                 Sympatico (Canada, www.sympatico.ca)

pns.dtag.de                                                                 T-Online (Deutschland, www.dtag.de)

dns-sol.swissonline.ch                                 SwissOnline (Switzerland, www.swissonline.ch)

main.piter.net                                                 PiterNet (Russia, www.piter.net)

Setting of DNS


SQL mailing lists (.SQL)
No contents entries on this page
This is the first topic
Go to home topic
This is the last topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

This list is a mailing list which is formed by database SQL-request on fly. File with SQL-request, you have added to box instead of mailing list, must have .SQL extension and the following format:

<ODBC Data Source>, <Username>, <Password>, <SQL Expression>

If access to ODBC data source don’t require the username and password then leave this fields blank. For example:

Customers,Admin,KmiaN82,SELECT email FROM customers WHERE account>3000

FromSQL,,,SELECT name,email FROM customers WHERE email<>NULL

SQL-request can return a several columns, in this case the columns values will sequentially form the mailing list line. The space character is used as separator for columns. The result of SQL-request is the list with the same limitations as a simple text mailing list. This list can contain only emails, but it can contain else real recipients names to fill in “To:” field.

Use SQL-lists together with FromSQL plugin for full-function merge of mail delivery and database. Sqlmail mailbox was created after program setup, you can try it after creation of ODBC data source with FromSQL name. Please, read carefully the article about FromSQL plugin before the creation and setting ODBC data source.

Mailing list formats, About FromSQL plugin


Simple mailing lists (.TXT, .LST)
No contents entries on this page
This is the first topic
Go to home topic
This is the last topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Simple text file, where each line contains one e-mail address. The maximum number of addresses in the mailing list is 1000000. If your list is longer, divide it into a few parts by AdrSplit utility and add this several lists to mailbox. Address can be written by any way, for example:

gorlach@mailutilities.com

<gorlach@mailutilities.com>

Alexander P. Gorlach <gorlach@mailutilities.com>

“Alexander P. Gorlach” gorlach@mailutilities.com

Alexander P. Gorlach gorlach@mailutilities.com

gorlach@mailutilities.com - Alexander P. Gorlach

The recommended method is the following :

Alexander P. Gorlach <gorlach@mailutilities.com>

Ivan Ivanov <ivanov@elcomsoft.com>

because ADR have the option, which allow to replace mail list address in “To:” field by email of real recipient. If you use this method then the most of mail clients show to message recipient his name in “To:” field without his email address.

Alexander P. Gorlach

Ivan Ivanov

If your mail list has some special format – just contact us, and we’ll probably support it in the future versions of ADR. Just note that most programs can export their data from their own formats to text files (and back) – for example, Outlook Express.

You also can use the special syntax of e-mail – MAILBOX@[SMTP-SERVER]. For example, to write in mailbox alex on smtp.enet.ru server, write alex@[smtp.enet.ru]. The server can be given by the domain or IP-address, the tcp-port can be specified, too (25 by default).

Mailing list formats


Windows Address Books (.WAB)
No contents entries on this page
This is the first topic
Go to home topic
This is the last topic

  • Scroll to top of this topic Scroll to Top of Page

  • Print the current topic Print Topic

  • No expanding elements on this page Show/Hide Expanders

Windows address books are storing in files with WAB extension. The path to address book may depend on Internet Explorer version. In operating systems, such as Windows 95, Windows 98 and Windows NT 4.0, the address books may be kept in the following directories:

\\Win95\Application Data\Microsoft\Address Book\USERNAME.WAB

\\Win98\Application Data\Microsoft\Address Book\USERNAME.WAB

\\WinNT\Profiles\USERNAME\Data\Microsoft\Address Book\USERNAME.WAB

You can add to some mailbox as an address book as a list in any other format. If you have in address book the mailing group (addresses group, distribution list) with MyGroup name and the mail box where you have added the address book has the same name then ADR extract from address book only those addresses that are included in MyGroup group. If in address book there is no group with the same name as mail box then ADR extract all e-mails from address book for delivery.

After extraction addresses from address book ADR eliminate the duplicates. Pay attention, ADR extract addresses from address book during delivery, i.e. the changes you make in address book will play a part in each new delivery. It’s better to use ADR than deliver message by address book with the help of Outlook Express because Outlook Express enumerate all recipients in To field. What not only enlarge message size but also declassify your address book contents.

Mailing list formats